<?php
/**
 * InlineResponse20071ContentTickets
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20071ContentTickets Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20071ContentTickets implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_71_content_tickets';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'companyId' => 'int',
        'remitterId' => 'int',
        'title' => 'string',
        'content' => 'string',
        'extTicketId' => 'string',
        'creationDate' => 'int',
        'assignedToEmployeeId' => 'int',
        'assignedToDepartmentId' => 'int',
        'assignmentName' => 'string',
        'statusId' => 'int',
        'typeId' => 'int',
        'linkTypeId' => 'int',
        'linkId' => 'int',
        'deadlineDate' => 'int',
        'project' => 'bool',
        'projectId' => 'int',
        'createdEmployeeId' => 'int',
        'repair' => 'bool',
        'dueDate' => 'int',
        'attention' => 'string',
        'orderById' => 'int',
        'installationFee' => 'string',
        'installationFeeDriveMode' => 'string',
        'installationFeeAmount' => 'double',
        'separateBilling' => 'bool',
        'serviceCapAmount' => 'double',
        'relationshipLinkTypeId' => 'int',
        'relationshipLinkId' => 'int',
        'resubmissionDate' => 'int',
        'estimatedMinutes' => 'int',
        'estimatedMinutesImage' => 'string',
        'localTicketAdminFlag' => 'string',
        'localTicketAdminEmployeeId' => 'int',
        'phaseId' => 'int',
        'resubmissionText' => 'string',
        'orderNumber' => 'string',
        'reminder' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'companyId' => null,
        'remitterId' => null,
        'title' => null,
        'content' => null,
        'extTicketId' => null,
        'creationDate' => 'timestamp',
        'assignedToEmployeeId' => null,
        'assignedToDepartmentId' => null,
        'assignmentName' => null,
        'statusId' => null,
        'typeId' => null,
        'linkTypeId' => null,
        'linkId' => null,
        'deadlineDate' => 'timestamp',
        'project' => null,
        'projectId' => null,
        'createdEmployeeId' => null,
        'repair' => null,
        'dueDate' => 'timestamp',
        'attention' => null,
        'orderById' => null,
        'installationFee' => null,
        'installationFeeDriveMode' => null,
        'installationFeeAmount' => 'double',
        'separateBilling' => null,
        'serviceCapAmount' => 'double',
        'relationshipLinkTypeId' => null,
        'relationshipLinkId' => null,
        'resubmissionDate' => 'timestamp',
        'estimatedMinutes' => null,
        'estimatedMinutesImage' => null,
        'localTicketAdminFlag' => null,
        'localTicketAdminEmployeeId' => null,
        'phaseId' => null,
        'resubmissionText' => null,
        'orderNumber' => null,
        'reminder' => 'timestamp'
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'companyId' => 'companyId',
        'remitterId' => 'remitterId',
        'title' => 'title',
        'content' => 'content',
        'extTicketId' => 'extTicketId',
        'creationDate' => 'creationDate',
        'assignedToEmployeeId' => 'assignedToEmployeeId',
        'assignedToDepartmentId' => 'assignedToDepartmentId',
        'assignmentName' => 'assignmentName',
        'statusId' => 'statusId',
        'typeId' => 'typeId',
        'linkTypeId' => 'linkTypeId',
        'linkId' => 'linkId',
        'deadlineDate' => 'deadlineDate',
        'project' => 'project',
        'projectId' => 'projectId',
        'createdEmployeeId' => 'createdEmployeeId',
        'repair' => 'repair',
        'dueDate' => 'dueDate',
        'attention' => 'attention',
        'orderById' => 'orderById',
        'installationFee' => 'installationFee',
        'installationFeeDriveMode' => 'installationFeeDriveMode',
        'installationFeeAmount' => 'installationFeeAmount',
        'separateBilling' => 'separateBilling',
        'serviceCapAmount' => 'serviceCapAmount',
        'relationshipLinkTypeId' => 'relationshipLinkTypeId',
        'relationshipLinkId' => 'relationshipLinkId',
        'resubmissionDate' => 'resubmissionDate',
        'estimatedMinutes' => 'estimatedMinutes',
        'estimatedMinutesImage' => 'estimatedMinutesImage',
        'localTicketAdminFlag' => 'localTicketAdminFlag',
        'localTicketAdminEmployeeId' => 'localTicketAdminEmployeeId',
        'phaseId' => 'phaseId',
        'resubmissionText' => 'resubmissionText',
        'orderNumber' => 'orderNumber',
        'reminder' => 'reminder'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'companyId' => 'setCompanyId',
        'remitterId' => 'setRemitterId',
        'title' => 'setTitle',
        'content' => 'setContent',
        'extTicketId' => 'setExtTicketId',
        'creationDate' => 'setCreationDate',
        'assignedToEmployeeId' => 'setAssignedToEmployeeId',
        'assignedToDepartmentId' => 'setAssignedToDepartmentId',
        'assignmentName' => 'setAssignmentName',
        'statusId' => 'setStatusId',
        'typeId' => 'setTypeId',
        'linkTypeId' => 'setLinkTypeId',
        'linkId' => 'setLinkId',
        'deadlineDate' => 'setDeadlineDate',
        'project' => 'setProject',
        'projectId' => 'setProjectId',
        'createdEmployeeId' => 'setCreatedEmployeeId',
        'repair' => 'setRepair',
        'dueDate' => 'setDueDate',
        'attention' => 'setAttention',
        'orderById' => 'setOrderById',
        'installationFee' => 'setInstallationFee',
        'installationFeeDriveMode' => 'setInstallationFeeDriveMode',
        'installationFeeAmount' => 'setInstallationFeeAmount',
        'separateBilling' => 'setSeparateBilling',
        'serviceCapAmount' => 'setServiceCapAmount',
        'relationshipLinkTypeId' => 'setRelationshipLinkTypeId',
        'relationshipLinkId' => 'setRelationshipLinkId',
        'resubmissionDate' => 'setResubmissionDate',
        'estimatedMinutes' => 'setEstimatedMinutes',
        'estimatedMinutesImage' => 'setEstimatedMinutesImage',
        'localTicketAdminFlag' => 'setLocalTicketAdminFlag',
        'localTicketAdminEmployeeId' => 'setLocalTicketAdminEmployeeId',
        'phaseId' => 'setPhaseId',
        'resubmissionText' => 'setResubmissionText',
        'orderNumber' => 'setOrderNumber',
        'reminder' => 'setReminder'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'companyId' => 'getCompanyId',
        'remitterId' => 'getRemitterId',
        'title' => 'getTitle',
        'content' => 'getContent',
        'extTicketId' => 'getExtTicketId',
        'creationDate' => 'getCreationDate',
        'assignedToEmployeeId' => 'getAssignedToEmployeeId',
        'assignedToDepartmentId' => 'getAssignedToDepartmentId',
        'assignmentName' => 'getAssignmentName',
        'statusId' => 'getStatusId',
        'typeId' => 'getTypeId',
        'linkTypeId' => 'getLinkTypeId',
        'linkId' => 'getLinkId',
        'deadlineDate' => 'getDeadlineDate',
        'project' => 'getProject',
        'projectId' => 'getProjectId',
        'createdEmployeeId' => 'getCreatedEmployeeId',
        'repair' => 'getRepair',
        'dueDate' => 'getDueDate',
        'attention' => 'getAttention',
        'orderById' => 'getOrderById',
        'installationFee' => 'getInstallationFee',
        'installationFeeDriveMode' => 'getInstallationFeeDriveMode',
        'installationFeeAmount' => 'getInstallationFeeAmount',
        'separateBilling' => 'getSeparateBilling',
        'serviceCapAmount' => 'getServiceCapAmount',
        'relationshipLinkTypeId' => 'getRelationshipLinkTypeId',
        'relationshipLinkId' => 'getRelationshipLinkId',
        'resubmissionDate' => 'getResubmissionDate',
        'estimatedMinutes' => 'getEstimatedMinutes',
        'estimatedMinutesImage' => 'getEstimatedMinutesImage',
        'localTicketAdminFlag' => 'getLocalTicketAdminFlag',
        'localTicketAdminEmployeeId' => 'getLocalTicketAdminEmployeeId',
        'phaseId' => 'getPhaseId',
        'resubmissionText' => 'getResubmissionText',
        'orderNumber' => 'getOrderNumber',
        'reminder' => 'getReminder'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const ATTENTION_FALSE = 'false';
    public const ATTENTION_TRUE = 'true';
    public const ATTENTION_RESUBMISSION = 'RESUBMISSION';
    public const ATTENTION_MAIL = 'MAIL';
    public const INSTALLATION_FEE_FALSE = 'false';
    public const INSTALLATION_FEE_TRUE = 'true';
    public const INSTALLATION_FEE_NO_PROJECT_INSTALLATION_FEE = 'NO_PROJECT_INSTALLATION_FEE';
    public const INSTALLATION_FEE_DRIVE_MODE_NONE = 'NONE';
    public const INSTALLATION_FEE_DRIVE_MODE_DRIVE_INCLUDED = 'DRIVE_INCLUDED';
    public const INSTALLATION_FEE_DRIVE_MODE_DRIVE_EXCLUDED = 'DRIVE_EXCLUDED';
    public const LOCAL_TICKET_ADMIN_FLAG_NONE = 'NONE';
    public const LOCAL_TICKET_ADMIN_FLAG_LOCAL_ADMIN = 'LOCAL_ADMIN';
    public const LOCAL_TICKET_ADMIN_FLAG_TECHNICIAN = 'TECHNICIAN';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAttentionAllowableValues()
    {
        return [
            self::ATTENTION_FALSE,
            self::ATTENTION_TRUE,
            self::ATTENTION_RESUBMISSION,
            self::ATTENTION_MAIL,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getInstallationFeeAllowableValues()
    {
        return [
            self::INSTALLATION_FEE_FALSE,
            self::INSTALLATION_FEE_TRUE,
            self::INSTALLATION_FEE_NO_PROJECT_INSTALLATION_FEE,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getInstallationFeeDriveModeAllowableValues()
    {
        return [
            self::INSTALLATION_FEE_DRIVE_MODE_NONE,
            self::INSTALLATION_FEE_DRIVE_MODE_DRIVE_INCLUDED,
            self::INSTALLATION_FEE_DRIVE_MODE_DRIVE_EXCLUDED,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getLocalTicketAdminFlagAllowableValues()
    {
        return [
            self::LOCAL_TICKET_ADMIN_FLAG_NONE,
            self::LOCAL_TICKET_ADMIN_FLAG_LOCAL_ADMIN,
            self::LOCAL_TICKET_ADMIN_FLAG_TECHNICIAN,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['remitterId'] = $data['remitterId'] ?? null;
        $this->container['title'] = $data['title'] ?? null;
        $this->container['content'] = $data['content'] ?? null;
        $this->container['extTicketId'] = $data['extTicketId'] ?? null;
        $this->container['creationDate'] = $data['creationDate'] ?? null;
        $this->container['assignedToEmployeeId'] = $data['assignedToEmployeeId'] ?? null;
        $this->container['assignedToDepartmentId'] = $data['assignedToDepartmentId'] ?? null;
        $this->container['assignmentName'] = $data['assignmentName'] ?? null;
        $this->container['statusId'] = $data['statusId'] ?? null;
        $this->container['typeId'] = $data['typeId'] ?? null;
        $this->container['linkTypeId'] = $data['linkTypeId'] ?? null;
        $this->container['linkId'] = $data['linkId'] ?? null;
        $this->container['deadlineDate'] = $data['deadlineDate'] ?? null;
        $this->container['project'] = $data['project'] ?? null;
        $this->container['projectId'] = $data['projectId'] ?? null;
        $this->container['createdEmployeeId'] = $data['createdEmployeeId'] ?? null;
        $this->container['repair'] = $data['repair'] ?? null;
        $this->container['dueDate'] = $data['dueDate'] ?? null;
        $this->container['attention'] = $data['attention'] ?? null;
        $this->container['orderById'] = $data['orderById'] ?? null;
        $this->container['installationFee'] = $data['installationFee'] ?? null;
        $this->container['installationFeeDriveMode'] = $data['installationFeeDriveMode'] ?? null;
        $this->container['installationFeeAmount'] = $data['installationFeeAmount'] ?? null;
        $this->container['separateBilling'] = $data['separateBilling'] ?? null;
        $this->container['serviceCapAmount'] = $data['serviceCapAmount'] ?? null;
        $this->container['relationshipLinkTypeId'] = $data['relationshipLinkTypeId'] ?? null;
        $this->container['relationshipLinkId'] = $data['relationshipLinkId'] ?? null;
        $this->container['resubmissionDate'] = $data['resubmissionDate'] ?? null;
        $this->container['estimatedMinutes'] = $data['estimatedMinutes'] ?? null;
        $this->container['estimatedMinutesImage'] = $data['estimatedMinutesImage'] ?? null;
        $this->container['localTicketAdminFlag'] = $data['localTicketAdminFlag'] ?? null;
        $this->container['localTicketAdminEmployeeId'] = $data['localTicketAdminEmployeeId'] ?? null;
        $this->container['phaseId'] = $data['phaseId'] ?? null;
        $this->container['resubmissionText'] = $data['resubmissionText'] ?? null;
        $this->container['orderNumber'] = $data['orderNumber'] ?? null;
        $this->container['reminder'] = $data['reminder'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getAttentionAllowableValues();
        if (!is_null($this->container['attention']) && !in_array($this->container['attention'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'attention', must be one of '%s'",
                $this->container['attention'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getInstallationFeeAllowableValues();
        if (!is_null($this->container['installationFee']) && !in_array($this->container['installationFee'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'installationFee', must be one of '%s'",
                $this->container['installationFee'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getInstallationFeeDriveModeAllowableValues();
        if (!is_null($this->container['installationFeeDriveMode']) && !in_array($this->container['installationFeeDriveMode'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'installationFeeDriveMode', must be one of '%s'",
                $this->container['installationFeeDriveMode'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getLocalTicketAdminFlagAllowableValues();
        if (!is_null($this->container['localTicketAdminFlag']) && !in_array($this->container['localTicketAdminFlag'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'localTicketAdminFlag', must be one of '%s'",
                $this->container['localTicketAdminFlag'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId Company id of the ticket. Name is stored in the \"linked entities\" - \"companies\". Can only be set if the user has access to the company
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets remitterId
     *
     * @return int|null
     */
    public function getRemitterId()
    {
        return $this->container['remitterId'];
    }

    /**
     * Sets remitterId
     *
     * @param int|null $remitterId If the ticket has a remitter, the id goes here. Name is stored in the \"linked entities\" - \"employees\"
     *
     * @return self
     */
    public function setRemitterId($remitterId)
    {
        $this->container['remitterId'] = $remitterId;

        return $this;
    }

    /**
     * Gets title
     *
     * @return string|null
     */
    public function getTitle()
    {
        return $this->container['title'];
    }

    /**
     * Sets title
     *
     * @param string|null $title The title / subject of the ticket
     *
     * @return self
     */
    public function setTitle($title)
    {
        $this->container['title'] = $title;

        return $this;
    }

    /**
     * Gets content
     *
     * @return string|null
     */
    public function getContent()
    {
        return $this->container['content'];
    }

    /**
     * Sets content
     *
     * @param string|null $content The content / description of the ticket
     *
     * @return self
     */
    public function setContent($content)
    {
        $this->container['content'] = $content;

        return $this;
    }

    /**
     * Gets extTicketId
     *
     * @return string|null
     */
    public function getExtTicketId()
    {
        return $this->container['extTicketId'];
    }

    /**
     * Sets extTicketId
     *
     * @param string|null $extTicketId External ticket id (optional)
     *
     * @return self
     */
    public function setExtTicketId($extTicketId)
    {
        $this->container['extTicketId'] = $extTicketId;

        return $this;
    }

    /**
     * Gets creationDate
     *
     * @return int|null
     */
    public function getCreationDate()
    {
        return $this->container['creationDate'];
    }

    /**
     * Sets creationDate
     *
     * @param int|null $creationDate creation date of tickets as unix timestamp
     *
     * @return self
     */
    public function setCreationDate($creationDate)
    {
        $this->container['creationDate'] = $creationDate;

        return $this;
    }

    /**
     * Gets assignedToEmployeeId
     *
     * @return int|null
     */
    public function getAssignedToEmployeeId()
    {
        return $this->container['assignedToEmployeeId'];
    }

    /**
     * Sets assignedToEmployeeId
     *
     * @param int|null $assignedToEmployeeId id of employee which ticket is assigned to. Name is stored in \"linked entities\" - \"employees\"
     *
     * @return self
     */
    public function setAssignedToEmployeeId($assignedToEmployeeId)
    {
        $this->container['assignedToEmployeeId'] = $assignedToEmployeeId;

        return $this;
    }

    /**
     * Gets assignedToDepartmentId
     *
     * @return int|null
     */
    public function getAssignedToDepartmentId()
    {
        return $this->container['assignedToDepartmentId'];
    }

    /**
     * Sets assignedToDepartmentId
     *
     * @param int|null $assignedToDepartmentId id of department which ticket is assigned to. Name is stored in \"linked entities\" - \"departments\"
     *
     * @return self
     */
    public function setAssignedToDepartmentId($assignedToDepartmentId)
    {
        $this->container['assignedToDepartmentId'] = $assignedToDepartmentId;

        return $this;
    }

    /**
     * Gets assignmentName
     *
     * @return string|null
     */
    public function getAssignmentName()
    {
        return $this->container['assignmentName'];
    }

    /**
     * Sets assignmentName
     *
     * @param string|null $assignmentName If ticket is assigned to a device (or employee), here the name is stored
     *
     * @return self
     */
    public function setAssignmentName($assignmentName)
    {
        $this->container['assignmentName'] = $assignmentName;

        return $this;
    }

    /**
     * Gets statusId
     *
     * @return int|null
     */
    public function getStatusId()
    {
        return $this->container['statusId'];
    }

    /**
     * Sets statusId
     *
     * @param int|null $statusId id of the ticket state. Name is give in \"linked entities\" - \"ticketStates\"
     *
     * @return self
     */
    public function setStatusId($statusId)
    {
        $this->container['statusId'] = $statusId;

        return $this;
    }

    /**
     * Gets typeId
     *
     * @return int|null
     */
    public function getTypeId()
    {
        return $this->container['typeId'];
    }

    /**
     * Sets typeId
     *
     * @param int|null $typeId id of the ticket type. Name is give in \"linked entities\" - \"ticketTypes\"
     *
     * @return self
     */
    public function setTypeId($typeId)
    {
        $this->container['typeId'] = $typeId;

        return $this;
    }

    /**
     * Gets linkTypeId
     *
     * @return int|null
     */
    public function getLinkTypeId()
    {
        return $this->container['linkTypeId'];
    }

    /**
     * Sets linkTypeId
     *
     * @param int|null $linkTypeId if ticket is assigned to device / employee, linktype is given here
     *
     * @return self
     */
    public function setLinkTypeId($linkTypeId)
    {
        $this->container['linkTypeId'] = $linkTypeId;

        return $this;
    }

    /**
     * Gets linkId
     *
     * @return int|null
     */
    public function getLinkId()
    {
        return $this->container['linkId'];
    }

    /**
     * Sets linkId
     *
     * @param int|null $linkId if ticket is assigned to device / employee, the id of the entity is given here
     *
     * @return self
     */
    public function setLinkId($linkId)
    {
        $this->container['linkId'] = $linkId;

        return $this;
    }

    /**
     * Gets deadlineDate
     *
     * @return int|null
     */
    public function getDeadlineDate()
    {
        return $this->container['deadlineDate'];
    }

    /**
     * Sets deadlineDate
     *
     * @param int|null $deadlineDate If ticket has a deadline, the date is given here
     *
     * @return self
     */
    public function setDeadlineDate($deadlineDate)
    {
        $this->container['deadlineDate'] = $deadlineDate;

        return $this;
    }

    /**
     * Gets project
     *
     * @return bool|null
     */
    public function getProject()
    {
        return $this->container['project'];
    }

    /**
     * Sets project
     *
     * @param bool|null $project if ticket is actually a project, this value is true
     *
     * @return self
     */
    public function setProject($project)
    {
        $this->container['project'] = $project;

        return $this;
    }

    /**
     * Gets projectId
     *
     * @return int|null
     */
    public function getProjectId()
    {
        return $this->container['projectId'];
    }

    /**
     * Sets projectId
     *
     * @param int|null $projectId if ticket is a sub-ticket of a project, the id of the project goes here. Name of the project is in the \"linked entities\" - \"tickets\"
     *
     * @return self
     */
    public function setProjectId($projectId)
    {
        $this->container['projectId'] = $projectId;

        return $this;
    }

    /**
     * Gets createdEmployeeId
     *
     * @return int|null
     */
    public function getCreatedEmployeeId()
    {
        return $this->container['createdEmployeeId'];
    }

    /**
     * Sets createdEmployeeId
     *
     * @param int|null $createdEmployeeId id of the employee who has created this ticket
     *
     * @return self
     */
    public function setCreatedEmployeeId($createdEmployeeId)
    {
        $this->container['createdEmployeeId'] = $createdEmployeeId;

        return $this;
    }

    /**
     * Gets repair
     *
     * @return bool|null
     */
    public function getRepair()
    {
        return $this->container['repair'];
    }

    /**
     * Sets repair
     *
     * @param bool|null $repair if true, this ticket is a \"repair ticket\"
     *
     * @return self
     */
    public function setRepair($repair)
    {
        $this->container['repair'] = $repair;

        return $this;
    }

    /**
     * Gets dueDate
     *
     * @return int|null
     */
    public function getDueDate()
    {
        return $this->container['dueDate'];
    }

    /**
     * Sets dueDate
     *
     * @param int|null $dueDate if ticket has a due date, the timestamp is given here
     *
     * @return self
     */
    public function setDueDate($dueDate)
    {
        $this->container['dueDate'] = $dueDate;

        return $this;
    }

    /**
     * Gets attention
     *
     * @return string|null
     */
    public function getAttention()
    {
        return $this->container['attention'];
    }

    /**
     * Sets attention
     *
     * @param string|null $attention Determines the \"attention\" flag state of a ticket
     *
     * @return self
     */
    public function setAttention($attention)
    {
        $allowedValues = $this->getAttentionAllowableValues();
        if (!is_null($attention) && !in_array($attention, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'attention', must be one of '%s'",
                    $attention,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['attention'] = $attention;

        return $this;
    }

    /**
     * Gets orderById
     *
     * @return int|null
     */
    public function getOrderById()
    {
        return $this->container['orderById'];
    }

    /**
     * Sets orderById
     *
     * @param int|null $orderById gives infos about how the remitter gave the order. Infos are stored in the \"linked entities\" - \"orderBys\"
     *
     * @return self
     */
    public function setOrderById($orderById)
    {
        $this->container['orderById'] = $orderById;

        return $this;
    }

    /**
     * Gets installationFee
     *
     * @return string|null
     */
    public function getInstallationFee()
    {
        return $this->container['installationFee'];
    }

    /**
     * Sets installationFee
     *
     * @param string|null $installationFee If the ticket has an installation fee, this value is true
     *
     * @return self
     */
    public function setInstallationFee($installationFee)
    {
        $allowedValues = $this->getInstallationFeeAllowableValues();
        if (!is_null($installationFee) && !in_array($installationFee, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'installationFee', must be one of '%s'",
                    $installationFee,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['installationFee'] = $installationFee;

        return $this;
    }

    /**
     * Gets installationFeeDriveMode
     *
     * @return string|null
     */
    public function getInstallationFeeDriveMode()
    {
        return $this->container['installationFeeDriveMode'];
    }

    /**
     * Sets installationFeeDriveMode
     *
     * @param string|null $installationFeeDriveMode Sets the installation fee drive mode. If it is set to NONE then the system config parameter \"leistung.ip.fahrzeit_berechnen\" will be used. If the company from the ticket has an installation fee drive mode set then that will be used instead of the system config parameter.
     *
     * @return self
     */
    public function setInstallationFeeDriveMode($installationFeeDriveMode)
    {
        $allowedValues = $this->getInstallationFeeDriveModeAllowableValues();
        if (!is_null($installationFeeDriveMode) && !in_array($installationFeeDriveMode, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'installationFeeDriveMode', must be one of '%s'",
                    $installationFeeDriveMode,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['installationFeeDriveMode'] = $installationFeeDriveMode;

        return $this;
    }

    /**
     * Gets installationFeeAmount
     *
     * @return double|null
     */
    public function getInstallationFeeAmount()
    {
        return $this->container['installationFeeAmount'];
    }

    /**
     * Sets installationFeeAmount
     *
     * @param double|null $installationFeeAmount Amount for the installation fee
     *
     * @return self
     */
    public function setInstallationFeeAmount($installationFeeAmount)
    {
        $this->container['installationFeeAmount'] = $installationFeeAmount;

        return $this;
    }

    /**
     * Gets separateBilling
     *
     * @return bool|null
     */
    public function getSeparateBilling()
    {
        return $this->container['separateBilling'];
    }

    /**
     * Sets separateBilling
     *
     * @param bool|null $separateBilling If true, the ticket shall be billed separately
     *
     * @return self
     */
    public function setSeparateBilling($separateBilling)
    {
        $this->container['separateBilling'] = $separateBilling;

        return $this;
    }

    /**
     * Gets serviceCapAmount
     *
     * @return double|null
     */
    public function getServiceCapAmount()
    {
        return $this->container['serviceCapAmount'];
    }

    /**
     * Sets serviceCapAmount
     *
     * @param double|null $serviceCapAmount if the ticket has a service cap, here the amount is given
     *
     * @return self
     */
    public function setServiceCapAmount($serviceCapAmount)
    {
        $this->container['serviceCapAmount'] = $serviceCapAmount;

        return $this;
    }

    /**
     * Gets relationshipLinkTypeId
     *
     * @return int|null
     */
    public function getRelationshipLinkTypeId()
    {
        return $this->container['relationshipLinkTypeId'];
    }

    /**
     * Sets relationshipLinkTypeId
     *
     * @param int|null $relationshipLinkTypeId linkTypeId of the relationship (if ticket has a relation)
     *
     * @return self
     */
    public function setRelationshipLinkTypeId($relationshipLinkTypeId)
    {
        $this->container['relationshipLinkTypeId'] = $relationshipLinkTypeId;

        return $this;
    }

    /**
     * Gets relationshipLinkId
     *
     * @return int|null
     */
    public function getRelationshipLinkId()
    {
        return $this->container['relationshipLinkId'];
    }

    /**
     * Sets relationshipLinkId
     *
     * @param int|null $relationshipLinkId linkId of the relationship (if ticket has a relation)
     *
     * @return self
     */
    public function setRelationshipLinkId($relationshipLinkId)
    {
        $this->container['relationshipLinkId'] = $relationshipLinkId;

        return $this;
    }

    /**
     * Gets resubmissionDate
     *
     * @return int|null
     */
    public function getResubmissionDate()
    {
        return $this->container['resubmissionDate'];
    }

    /**
     * Sets resubmissionDate
     *
     * @param int|null $resubmissionDate if the ticket as a resubmission date set, this is given here
     *
     * @return self
     */
    public function setResubmissionDate($resubmissionDate)
    {
        $this->container['resubmissionDate'] = $resubmissionDate;

        return $this;
    }

    /**
     * Gets estimatedMinutes
     *
     * @return int|null
     */
    public function getEstimatedMinutes()
    {
        return $this->container['estimatedMinutes'];
    }

    /**
     * Sets estimatedMinutes
     *
     * @param int|null $estimatedMinutes Number of estimated minutes which is planned for the ticket
     *
     * @return self
     */
    public function setEstimatedMinutes($estimatedMinutes)
    {
        $this->container['estimatedMinutes'] = $estimatedMinutes;

        return $this;
    }

    /**
     * Gets estimatedMinutesImage
     *
     * @return string|null
     */
    public function getEstimatedMinutesImage()
    {
        return $this->container['estimatedMinutesImage'];
    }

    /**
     * Sets estimatedMinutesImage
     *
     * @param string|null $estimatedMinutesImage This is used to display the correct image for the \"estimated minutes\" icon in the ticket lists
     *
     * @return self
     */
    public function setEstimatedMinutesImage($estimatedMinutesImage)
    {
        $this->container['estimatedMinutesImage'] = $estimatedMinutesImage;

        return $this;
    }

    /**
     * Gets localTicketAdminFlag
     *
     * @return string|null
     */
    public function getLocalTicketAdminFlag()
    {
        return $this->container['localTicketAdminFlag'];
    }

    /**
     * Sets localTicketAdminFlag
     *
     * @param string|null $localTicketAdminFlag Determines wether the ticket is assigned to a local ticket admin or not - NONE: \"normal\" ticket - LOCAL_ADMIN: ticket is assigned to a local ticket admin - TECHNICIAN: local ticket admin has forwarded the ticket to a technician
     *
     * @return self
     */
    public function setLocalTicketAdminFlag($localTicketAdminFlag)
    {
        $allowedValues = $this->getLocalTicketAdminFlagAllowableValues();
        if (!is_null($localTicketAdminFlag) && !in_array($localTicketAdminFlag, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'localTicketAdminFlag', must be one of '%s'",
                    $localTicketAdminFlag,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['localTicketAdminFlag'] = $localTicketAdminFlag;

        return $this;
    }

    /**
     * Gets localTicketAdminEmployeeId
     *
     * @return int|null
     */
    public function getLocalTicketAdminEmployeeId()
    {
        return $this->container['localTicketAdminEmployeeId'];
    }

    /**
     * Sets localTicketAdminEmployeeId
     *
     * @param int|null $localTicketAdminEmployeeId if the ticket is assigned to a local ticket admin, this represents the employee (local ticket admin) who is assigned for this ticket
     *
     * @return self
     */
    public function setLocalTicketAdminEmployeeId($localTicketAdminEmployeeId)
    {
        $this->container['localTicketAdminEmployeeId'] = $localTicketAdminEmployeeId;

        return $this;
    }

    /**
     * Gets phaseId
     *
     * @return int|null
     */
    public function getPhaseId()
    {
        return $this->container['phaseId'];
    }

    /**
     * Sets phaseId
     *
     * @param int|null $phaseId if the ticket is assignet to a project phase. The name of the phase is stored in the \"linked entities\" - \"phases\"
     *
     * @return self
     */
    public function setPhaseId($phaseId)
    {
        $this->container['phaseId'] = $phaseId;

        return $this;
    }

    /**
     * Gets resubmissionText
     *
     * @return string|null
     */
    public function getResubmissionText()
    {
        return $this->container['resubmissionText'];
    }

    /**
     * Sets resubmissionText
     *
     * @param string|null $resubmissionText If a resubmission text is set, this text is returned here
     *
     * @return self
     */
    public function setResubmissionText($resubmissionText)
    {
        $this->container['resubmissionText'] = $resubmissionText;

        return $this;
    }

    /**
     * Gets orderNumber
     *
     * @return string|null
     */
    public function getOrderNumber()
    {
        return $this->container['orderNumber'];
    }

    /**
     * Sets orderNumber
     *
     * @param string|null $orderNumber Sets the order number
     *
     * @return self
     */
    public function setOrderNumber($orderNumber)
    {
        $this->container['orderNumber'] = $orderNumber;

        return $this;
    }

    /**
     * Gets reminder
     *
     * @return int|null
     */
    public function getReminder()
    {
        return $this->container['reminder'];
    }

    /**
     * Sets reminder
     *
     * @param int|null $reminder If the ticket has a reminder set, the timestamp is returned here
     *
     * @return self
     */
    public function setReminder($reminder)
    {
        $this->container['reminder'] = $reminder;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


